unit USBUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, USB_HID, ComCtrls;

type
  TForm1 = class(TForm)
    SGrid: TStringGrid;
    EditNoOfDevices: TEdit;
    Label1: TLabel;
    SEDevNo: TSpinEdit;
    Button1: TButton;
    EditDevPath: TEdit;
    LabeDevPath: TLabel;
    Label2: TLabel;
    LabelFrendlyName: TLabel;
    EditFrendlyName: TEdit;
    EditVenderID: TEdit;
    EditProductID: TEdit;
    LabelVenderID: TLabel;
    Label3: TLabel;
    RichEdit1: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SEDevNoChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Dev: THIDDevice;
  Aval: Boolean;
  DevPath: AnsiString;
  VenderID: Word;
  ProductID: Word;
  FrendlyName: string;
  USBMan: TUSBManager;
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   X: Word;
begin
USBMan := TUSBManager.Create;
USBMan.InitializeDeviceList;
 SGrid.ColWidths[0] := 120;
 SGrid.ColWidths[1] := 215;
For X := 0 to SGrid.RowCount -1 do SGrid.RowHeights[X] := 16;
SEDevNo.MaxValue := USBMan.GetDeviceCount;
EditNoOfDevices.Text := IntToStr(USBMan.GetDeviceCount);
SEDevNoChange(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
USBMan.FreeDeviceList;
USBMan.InitializeDeviceList;
 USBMan.SetDeviceForAccess(DevPath);
//  begin
SGrid.Cells[0,0] := 'Device Description';
 SGrid.Cells[1,0] := AnsiToStr(USBMan.ClassDescr);
SGrid.Cells[0,1] := 'HardwareID0';
 SGrid.Cells[1,1] := AnsiToStr(USBMan.HardwareID);
SGrid.Cells[0,2] := 'HardwareID1';
 SGrid.Cells[1,2] := AnsiToStr(USBMan.HardwareID);
SGrid.Cells[0,3] := 'InstallState 1, 3';
 SGrid.Cells[1,3] := IntToHex(USBMan.InstallState, 1);
SGrid.Cells[0,4] := 'CompatibleIDs0';
 SGrid.Cells[1,4] := AnsiToStr(USBMan.CompatibleIDs);
SGrid.Cells[0,5] := 'CompatibleIDs1';
 SGrid.Cells[1,5] := AnsiToStr(USBMan.CompatibleIDs);
SGrid.Cells[0,6] := 'Service';
 SGrid.Cells[1,6] := AnsiToStr(USBMan.Service);
SGrid.Cells[0,7] := 'Class';
 SGrid.Cells[1,7] := AnsiToStr(USBMan.Class_);
SGrid.Cells[0,8] := 'ClassGUID';
 SGrid.Cells[1,8] := AnsiToStr(USBMan.ClassGUID);
SGrid.Cells[0,9] := 'Driver';
 SGrid.Cells[1,9] := AnsiToStr(USBMan.Driver);
SGrid.Cells[0,10] := 'Config Flags (DWord)';
 SGrid.Cells[1,10] := IntToHex(USBMan.ConfigFlags, 8);
SGrid.Cells[0,11] := 'MFG';
 SGrid.Cells[1,11] := AnsiToStr(USBMan.Mfg);
SGrid.Cells[0,12] := 'FriendlyName';
 SGrid.Cells[1,12] := AnsiToStr(USBMan.FriendlyName);
SGrid.Cells[0,13] := 'Location Information';
 SGrid.Cells[1,13] := AnsiToStr(USBMan.LocationInfo);
SGrid.Cells[0,14] := 'Phys Dev Obj Name';
 SGrid.Cells[1,14] := AnsiToStr(USBMan.PhysDevObjName);
SGrid.Cells[0,15] := 'Capabilities (DWord)';
 SGrid.Cells[1,15] := IntToHex(Int64(USBMan.Capabilities),8);
SGrid.Cells[0,16] := 'UI Number (DWord)';
 SGrid.Cells[1,16] := IntToHex(Int64(USBMan.UINumber), 8);
SGrid.Cells[0,17] := 'UpperFilters';
 SGrid.Cells[1,17] := AnsiToStr(USBMan.UpperFilters);
SGrid.Cells[0,18] := 'LowerFilters';
 SGrid.Cells[1,18] := AnsiToStr(USBMan.LowerFilters);
SGrid.Cells[0,19] := 'BusType (DWord)';
 SGrid.Cells[1,19] := IntToHex(Int64(USBMan.BusTypeGUID), 8);
SGrid.Cells[0,20] := 'Legacy Bus Type';
 SGrid.Cells[1,20] := IntToHex(Int64(USBMan.LegacyBusType), 8);
SGrid.Cells[0,21] := 'Bus Number (DWord)';
 SGrid.Cells[1,21] := IntToHex(Int64(USBMan.BusNumber), 8);
SGrid.Cells[0,22] := 'Enumerator Name';
 SGrid.Cells[1,22] := AnsiToStr(USBMan.EnumeratorName);
SGrid.Cells[0,23] := 'Security';
 SGrid.Cells[1,23] := AnsiToStr(USBMan.Security);
SGrid.Cells[0,24] := 'Security SDS';
 SGrid.Cells[1,24] := AnsiToStr(USBMan.SecuritySDS);
SGrid.Cells[0,25] := 'DevType (DWord)';
 SGrid.Cells[1,25] := IntToHex(USBMan.Exclusive, 8);
SGrid.Cells[26,0] := 'Characteristics';
 SGrid.Cells[26,1] := AnsiToStr(USBMan.Characteristics);
SGrid.Cells[27,0] := 'Address';
 SGrid.Cells[27,1] := AnsiToStr(USBMan.Address);
end;


procedure TForm1.SEDevNoChange(Sender: TObject);
begin
If USBMan.GetDeviceCount > 1 then
   SEDevNo.MaxValue := USBMan.GetDeviceCount -1;
If SEDevNo.Value < 0 then SEDevNo.Value := 0;
 USBMan.FindDevice(Byte(SEDevNo.Value), DevPath, VenderID, ProductID, FrendlyName);
  EditDevPath.Text := AnsiToStr(DevPath);
   EditFrendlyName.Text := FrendlyName;
  EditVenderID.Text := IntToHex(VenderID, 4);
 EditProductID.Text := IntToHex(ProductID, 4);
end;

end.
